



<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="Network API, manipulate your network infrastructure as code">
      
      
        <link rel="canonical" href="https://davidban77.gitlab.io/netapi/">
      
      
        <meta name="author" content="David Flores">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.0.4, mkdocs-material-4.4.3">
    
    
      
        <title>NetAPI</title>
      
    
    
      <link rel="stylesheet" href="assets/stylesheets/application.30686662.css">
      
        <link rel="stylesheet" href="assets/stylesheets/application-palette.a8b3c06d.css">
      
      
        
        
        <meta name="theme-color" content="#009688">
      
    
    
      <script src="assets/javascripts/modernizr.74668098.js"></script>
    
    
      
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono&display=fallback">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
    
    <link rel="stylesheet" href="assets/fonts/material-icons.css">
    
    
    
      
    
    
  </head>
  
    
    
    <body dir="ltr" data-md-color-primary="teal" data-md-color-accent="teal">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="500" height="500" viewBox="0 0 500 500" id="__gitlab"><path fill="currentColor" d="M93.667 473.347l90.684-279.097H2.983l90.684 279.097z" transform="translate(156.198 1.16)"/><path fill="currentColor" d="M221.333 473.345L130.649 194.25H3.557l217.776 279.095z" transform="translate(28.531 1.16)" opacity=".7"/><path fill="currentColor" d="M32 195.155L4.441 279.97a18.773 18.773 0 0 0 6.821 20.99l238.514 173.29L32 195.155z" transform="translate(.089 .256)" opacity=".5"/><path fill="currentColor" d="M2.667-84.844h127.092L75.14-252.942c-2.811-8.649-15.047-8.649-17.856 0L2.667-84.844z" transform="translate(29.422 280.256)"/><path fill="currentColor" d="M2.667 473.345L93.351 194.25h127.092L2.667 473.345z" transform="translate(247.198 1.16)" opacity=".7"/><path fill="currentColor" d="M221.334 195.155l27.559 84.815a18.772 18.772 0 0 1-6.821 20.99L3.557 474.25l217.777-279.095z" transform="translate(246.307 .256)" opacity=".5"/><path fill="currentColor" d="M130.667-84.844H3.575l54.618-168.098c2.811-8.649 15.047-8.649 17.856 0l54.618 168.098z" transform="translate(336.974 280.256)"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="__drawer"></label>
    
      <a href="#installation" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="https://davidban77.gitlab.io/netapi" title="NetAPI" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="__drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            <span class="md-header-nav__topic">
              NetAPI
            </span>
            <span class="md-header-nav__topic">
              
                Overview
              
            </span>
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          <label class="md-icon md-icon--search md-header-nav__button" for="__search"></label>
          
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="__search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  

<a href="https://gitlab.com/the-networkers/netaudithor/netapi/" title="Go to repository" class="md-source" data-md-source="gitlab">
  
    <div class="md-source__icon">
      <svg viewBox="0 0 24 24" width="24" height="24">
        <use xlink:href="#__gitlab" width="24" height="24"></use>
      </svg>
    </div>
  
  <div class="md-source__repository">
    netaudithor/netapi
  </div>
</a>
          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
        

<nav class="md-tabs" data-md-component="tabs">
  <div class="md-tabs__inner md-grid">
    <ul class="md-tabs__list">
      
        
  <li class="md-tabs__item">
    
      <a href="." class="md-tabs__link md-tabs__link--active">
        Overview
      </a>
    
  </li>

      
        
  
  
    
    
  
  
    <li class="md-tabs__item">
      
        <a href="api/api_net_reference/" class="md-tabs__link">
          API Reference
        </a>
      
    </li>
  

  

      
        
  
  
    <li class="md-tabs__item">
      
        <a href="about/changelog/" class="md-tabs__link">
          About
        </a>
      
    </li>
  

      
    </ul>
  </div>
</nav>
      
      <main class="md-main" role="main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="__drawer">
    <a href="https://davidban77.gitlab.io/netapi" title="NetAPI" class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </a>
    NetAPI
  </label>
  
    <div class="md-nav__source">
      


  

<a href="https://gitlab.com/the-networkers/netaudithor/netapi/" title="Go to repository" class="md-source" data-md-source="gitlab">
  
    <div class="md-source__icon">
      <svg viewBox="0 0 24 24" width="24" height="24">
        <use xlink:href="#__gitlab" width="24" height="24"></use>
      </svg>
    </div>
  
  <div class="md-source__repository">
    netaudithor/netapi
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        Overview
      </label>
    
    <a href="." title="Overview" class="md-nav__link md-nav__link--active">
      Overview
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#installation" class="md-nav__link">
    Installation
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#development-version" class="md-nav__link">
    Development Version
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-it-works" class="md-nav__link">
    How it works
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#network-entities-example" class="md-nav__link">
    Network Entities example
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-probes-example" class="md-nav__link">
    Network Probes example
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#supported-implementations" class="md-nav__link">
    Supported Implementations
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#connectors" class="md-nav__link">
    Connectors
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-entities" class="md-nav__link">
    Network Entities
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-probes" class="md-nav__link">
    Network Probes
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2">
    
    <label class="md-nav__link" for="nav-2">
      API Reference
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        API Reference
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-1" type="checkbox" id="nav-2-1">
    
    <label class="md-nav__link" for="nav-2-1">
      Net Entities
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-1">
        Net Entities
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_net_reference/" title="Builders and Net Objects" class="md-nav__link">
      Builders and Net Objects
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_net_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-2" type="checkbox" id="nav-2-2">
    
    <label class="md-nav__link" for="nav-2-2">
      Connectors
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-2">
        Connectors
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_connector_reference/" title="Builders and Connector Objects" class="md-nav__link">
      Builders and Connector Objects
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_connector_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_connector_linux_reference/" title="Linux" class="md-nav__link">
      Linux
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-3" type="checkbox" id="nav-2-3">
    
    <label class="md-nav__link" for="nav-2-3">
      Probes
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-3">
        Probes
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_reference/" title="Builders and Probe Objects" class="md-nav__link">
      Builders and Probe Objects
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_ios_reference/" title="IOS" class="md-nav__link">
      IOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_xe_reference/" title="IOS-XE" class="md-nav__link">
      IOS-XE
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_xr_reference/" title="IOS-XR" class="md-nav__link">
      IOS-XR
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_nxos_reference/" title="NXOS" class="md-nav__link">
      NXOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_junos_reference/" title="JUNOS" class="md-nav__link">
      JUNOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="api/api_probe_linux_reference/" title="Linux" class="md-nav__link">
      Linux
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      About
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        About
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="about/changelog/" title="Release Notes" class="md-nav__link">
      Release Notes
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="about/license/" title="License" class="md-nav__link">
      License
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#installation" class="md-nav__link">
    Installation
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#development-version" class="md-nav__link">
    Development Version
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-it-works" class="md-nav__link">
    How it works
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#network-entities-example" class="md-nav__link">
    Network Entities example
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-probes-example" class="md-nav__link">
    Network Probes example
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#supported-implementations" class="md-nav__link">
    Supported Implementations
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#connectors" class="md-nav__link">
    Connectors
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-entities" class="md-nav__link">
    Network Entities
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#network-probes" class="md-nav__link">
    Network Probes
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://gitlab.com/the-networkers/netaudithor/netapi/edit/master/docs/index.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                  <h1>Overview</h1>
                
                <p>Network API library that perform the core of the work -&gt; requests execution and data parsing.</p>
<p>It relies on the main vendor libraries to perform its work and its main objective to grant network objects that can be used with your applications.</p>
<h2 id="installation">Installation<a class="headerlink" href="#installation" title="Permanent link">*</a></h2>
<p>You can directly install it using pip</p>
<div class="codehilite"><pre><span></span>pip install netapi
</pre></div>


<h3 id="development-version">Development Version<a class="headerlink" href="#development-version" title="Permanent link">*</a></h3>
<p>You will need <a href="https://github.com/sdispater/poetry">poetry</a> for clonning and installing the repo</p>
<h2 id="how-it-works">How it works<a class="headerlink" href="#how-it-works" title="Permanent link">*</a></h2>
<p>Is a library that abstracts the connection and parsing method of the data collected on the target device. It then presents a developer-friendly object that you can use to interact with.</p>
<p>All the objects are created with some cool features for manipulating their attributes and creating your applications on top of it. An example is the <code>IPNetwork</code> object returned of the ipv4 address of an interface. You will see that later.</p>
<p>The library is divided in 3 main types of objects:</p>
<ul>
<li><strong>Device</strong>: These are connector objects used fot the <code>net</code> and <code>probes</code> objects. Needed for the execution and data collection.</li>
<li><strong>Net</strong>: These are network <em>entities</em>, which basically means technologies or parts of the network protocols like interface, vlan, vrrp, bgp, etc...</li>
<li><strong>Probes</strong>: These are tester objects to run in your <code>device</code> objects. For example <code>ping</code> or <code>trace</code>.</li>
</ul>
<p>There is also a <code>Metadata</code> object that collects information about the implementation, how many times the object has been executed and timestamp. Useful for reports and other tests.</p>
<h3 id="network-entities-example">Network Entities example<a class="headerlink" href="#network-entities-example" title="Permanent link">*</a></h3>
<p>Here is an example of how to use the library when using a network entity. In this case <code>Interface</code>:</p>
<div class="codehilite"><pre><span></span><span class="c1"># Use Arista pyeapi client for connection</span>
<span class="kn">from</span> <span class="nn">netapi.connector.eos.pyeapier</span> <span class="kn">import</span> <span class="n">Device</span>
<span class="kn">from</span> <span class="nn">netapi.net.eos.pyeapier</span> <span class="kn">import</span> <span class="n">Interface</span>

<span class="kn">from</span> <span class="nn">pprint</span> <span class="kn">import</span> <span class="n">pprint</span>

<span class="c1"># Create a device connection object using its api https interface</span>
<span class="n">router01</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span>
    <span class="n">host</span><span class="o">=</span><span class="s2">&quot;192.168.0.77&quot;</span><span class="p">,</span>
    <span class="n">username</span><span class="o">=</span><span class="s2">&quot;someuser&quot;</span><span class="p">,</span>
    <span class="n">password</span><span class="o">=</span><span class="s2">&quot;somepassword&quot;</span><span class="p">,</span>
    <span class="n">transport</span><span class="o">=</span><span class="s2">&quot;https&quot;</span>
<span class="p">)</span>
</pre></div>


<p>Show device connection attributes, notice that secrets are hidden</p>
<div class="codehilite"><pre><span></span><span class="k">print</span><span class="p">(</span><span class="n">router01</span><span class="p">)</span>

<span class="n">Device</span><span class="p">(</span><span class="n">host</span><span class="o">=</span><span class="s1">&#39;192.168.0.77&#39;</span><span class="p">,</span> <span class="n">username</span><span class="o">=</span><span class="s1">&#39;someuser&#39;</span><span class="p">,</span> <span class="n">port</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">net_os</span><span class="o">=</span><span class="s1">&#39;eos&#39;</span><span class="p">,</span> <span class="n">transport</span><span class="o">=</span><span class="s1">&#39;https&#39;</span><span class="p">)</span>
</pre></div>


<p>You can see the metadata for this instance and get information like timestamp, type of implementation, id of the instance, among other things:</p>
<div class="codehilite"><pre><span></span><span class="k">print</span><span class="p">(</span><span class="n">router01</span><span class="o">.</span><span class="n">metadata</span><span class="p">)</span>

<span class="n">Metadata</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;device&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="s1">&#39;entity&#39;</span><span class="p">,</span> <span class="n">implementation</span><span class="o">=</span><span class="s1">&#39;EOS-PYEAPI&#39;</span><span class="p">,</span> <span class="n">created_at</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="mi">16</span><span class="p">,</span> <span class="mi">47</span><span class="p">,</span> <span class="mi">35</span><span class="p">,</span> <span class="mi">319134</span><span class="p">),</span> <span class="nb">id</span><span class="o">=</span><span class="n">UUID</span><span class="p">(</span><span class="s1">&#39;51d317ab-584d-4f32-a789-402770c361f2&#39;</span><span class="p">),</span> <span class="n">updated_at</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">collection_count</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="bp">None</span><span class="p">)</span>
</pre></div>


<p>You can run a command/action and retrieve its output. The format would depend mostly of the device, net_os, implementation (like EOS-PYEAPI or raw SSH for example) and the type of command.</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">pprint</span><span class="p">(</span><span class="n">router01</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="s1">&#39;show version&#39;</span><span class="p">))</span>

<span class="p">{</span><span class="s1">&#39;show version&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;architecture&#39;</span><span class="p">:</span> <span class="s1">&#39;i386&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;bootupTimestamp&#39;</span><span class="p">:</span> <span class="mf">1557851831.0</span><span class="p">,</span>
                  <span class="s1">&#39;hardwareRevision&#39;</span><span class="p">:</span> <span class="s1">&#39;&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;internalBuildId&#39;</span><span class="p">:</span> <span class="s1">&#39;1a44ce37-92c4-48b6-b922-38b7eed939b6&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;internalVersion&#39;</span><span class="p">:</span> <span class="s1">&#39;4.21.5F-11604264.4215F&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;isIntlVersion&#39;</span><span class="p">:</span> <span class="bp">False</span><span class="p">,</span>
                  <span class="s1">&#39;memFree&#39;</span><span class="p">:</span> <span class="mi">1372616</span><span class="p">,</span>
                  <span class="s1">&#39;memTotal&#39;</span><span class="p">:</span> <span class="mi">2015608</span><span class="p">,</span>
                  <span class="s1">&#39;mfgName&#39;</span><span class="p">:</span> <span class="s1">&#39;&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;modelName&#39;</span><span class="p">:</span> <span class="s1">&#39;vEOS&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;serialNumber&#39;</span><span class="p">:</span> <span class="s1">&#39;&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;systemMacAddress&#39;</span><span class="p">:</span> <span class="s1">&#39;0c:59:30:85:d7:1d&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;uptime&#39;</span><span class="p">:</span> <span class="mf">1158.4</span><span class="p">,</span>
                  <span class="s1">&#39;version&#39;</span><span class="p">:</span> <span class="s1">&#39;4.21.5F&#39;</span><span class="p">}}</span>
</pre></div>


<p>This library provides common handlers,  for well known network technologies. Here is an example for the Management 1 interface. Notice that I pass the device connector object:</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">mgmt1</span> <span class="o">=</span> <span class="n">Interface</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;Management1&quot;</span><span class="p">,</span> <span class="n">connector</span><span class="o">=</span><span class="n">router01</span><span class="p">)</span>

<span class="c1"># You can collect its attributes by running the get() method</span>
<span class="o">&gt;&gt;&gt;</span> <span class="n">mgmt1</span><span class="o">.</span><span class="n">get</span><span class="p">()</span>
</pre></div>


<p>You can see its attributes. Since it is an interface I will only show some key ones</p>
<div class="codehilite"><pre><span></span><span class="k">print</span><span class="p">(</span><span class="n">mgmt1</span><span class="p">)</span>

<span class="n">Interface</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;Management1&#39;</span><span class="p">,</span>
          <span class="n">description</span><span class="o">=</span><span class="s1">&#39;Some description&#39;</span><span class="p">,</span>
          <span class="n">enabled</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span>
          <span class="n">instance</span><span class="o">=</span><span class="s1">&#39;MANAGEMENT&#39;</span><span class="p">,</span>
          <span class="n">members</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
          <span class="n">status_up</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span>
          <span class="n">status</span><span class="o">=</span><span class="s1">&#39;connected&#39;</span><span class="p">,</span>
          <span class="n">last_status_change</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">11</span><span class="p">,</span> <span class="mi">40</span><span class="p">,</span> <span class="mi">38</span><span class="p">,</span> <span class="mi">144796</span><span class="p">,</span> <span class="n">tzinfo</span><span class="o">=</span><span class="n">Timezone</span><span class="p">(</span><span class="s1">&#39;Europe/Dublin&#39;</span><span class="p">)),</span>
          <span class="n">number_status_changes</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span>
          <span class="n">last_clear</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">11</span><span class="p">,</span> <span class="mi">34</span><span class="p">,</span> <span class="mi">32</span><span class="p">,</span> <span class="mi">150340</span><span class="p">,</span> <span class="n">tzinfo</span><span class="o">=</span><span class="n">Timezone</span><span class="p">(</span><span class="s1">&#39;Europe/Dublin&#39;</span><span class="p">)),</span>
          <span class="n">update_interval</span><span class="o">=</span><span class="mf">5.0</span><span class="p">,</span>
          <span class="n">forwarding_model</span><span class="o">=</span><span class="s1">&#39;routed&#39;</span><span class="p">,</span>
          <span class="n">physical</span><span class="o">=</span><span class="n">InterfacePhysical</span><span class="p">(</span><span class="n">mtu</span><span class="o">=</span><span class="n">Byte</span><span class="p">(</span><span class="mf">1500.0</span><span class="p">),</span>
                                     <span class="n">bandwidth</span><span class="o">=</span><span class="n">Bit</span><span class="p">(</span><span class="mf">1000000000.0</span><span class="p">),</span>
                                     <span class="n">duplex</span><span class="o">=</span><span class="s1">&#39;duplexFull&#39;</span><span class="p">,</span>
                                     <span class="n">mac</span><span class="o">=</span><span class="n">EUI</span><span class="p">(</span><span class="s1">&#39;28-99-3A-F8-5D-E7&#39;</span><span class="p">)),</span>
          <span class="n">optical</span><span class="o">=</span><span class="n">InterfaceOptical</span><span class="p">(</span><span class="n">tx</span><span class="o">=-</span><span class="mf">2.5</span><span class="p">,</span>
                                   <span class="n">rx</span><span class="o">=-</span><span class="mf">5.4</span><span class="p">,</span>
                                   <span class="n">status</span><span class="o">=</span><span class="s2">&quot;green&quot;</span><span class="p">,</span>
                                   <span class="n">serial_number</span><span class="o">=</span><span class="s2">&quot;XXXYYYZZZ&quot;</span><span class="p">,</span>
                                   <span class="n">media_type</span><span class="o">=</span><span class="s2">&quot;10GBASE-SR&quot;</span><span class="p">),</span>
          <span class="n">addresses</span><span class="o">=</span><span class="n">InterfaceIP</span><span class="p">(</span><span class="n">ipv4</span><span class="o">=</span><span class="n">IPNetwork</span><span class="p">(</span><span class="s1">&#39;10.193.0.177/24&#39;</span><span class="p">),</span>
                                <span class="n">ipv6</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
                                <span class="n">secondary_ipv4</span><span class="o">=</span><span class="p">[],</span>
                                <span class="n">dhcp</span><span class="o">=</span><span class="bp">None</span><span class="p">))</span>
</pre></div>


<p>NOTE: The <code>counters</code> attribute is not refelcted by default. You can access it directly with <code>&lt;interface_obj&gt;.counters</code></p>
<p>There are multiple parameters here but and I ommitted othere but you can see that IP addresses are netaddr IPNetwork object and similarly the MAC addresses are EUI objects. Also the counter_refresh interval are datetime objects.</p>
<p>These instances also have metadata</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">mgmt1</span><span class="o">.</span><span class="n">metadata</span><span class="p">)</span>

<span class="n">Metadata</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;interface&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="s1">&#39;entity&#39;</span><span class="p">,</span> <span class="n">implementation</span><span class="o">=</span><span class="s1">&#39;EOS-PYEAPI&#39;</span><span class="p">,</span> <span class="n">created_at</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="mi">16</span><span class="p">,</span> <span class="mi">43</span><span class="p">,</span> <span class="mi">44</span><span class="p">,</span> <span class="mi">819105</span><span class="p">),</span> <span class="nb">id</span><span class="o">=</span><span class="n">UUID</span><span class="p">(</span><span class="s1">&#39;73297adf-a0d6-4f8d-b247-0d793e577efb&#39;</span><span class="p">),</span> <span class="n">updated_at</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="mi">16</span><span class="p">,</span> <span class="mi">43</span><span class="p">,</span> <span class="mi">54</span><span class="p">,</span> <span class="mi">483277</span><span class="p">),</span> <span class="n">collection_count</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="bp">None</span><span class="p">)</span>
</pre></div>


<p>You can see that in the metadata the updated_at field is populated? This happened because we invoked the get() method to collect the data. Now let's change the interface description and refresh the interface data (this is done outside of the script)</p>
<p>Assuming a change to the description was done, now retrieve again the data</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">mgmt01</span><span class="o">.</span><span class="n">description</span><span class="p">)</span>

<span class="n">DUMMY</span> <span class="n">DESCRIPTION</span>
</pre></div>


<p>You can see that the description changes but also the metadata has been updated!</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">mgmt01</span><span class="o">.</span><span class="n">metadata</span><span class="p">)</span>

<span class="n">Metadata</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;interface&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="s1">&#39;entity&#39;</span><span class="p">,</span> <span class="n">implementation</span><span class="o">=</span><span class="s1">&#39;EOS-PYEAPI&#39;</span><span class="p">,</span> <span class="n">created_at</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="mi">16</span><span class="p">,</span> <span class="mi">43</span><span class="p">,</span> <span class="mi">44</span><span class="p">,</span> <span class="mi">819105</span><span class="p">),</span> <span class="nb">id</span><span class="o">=</span><span class="n">UUID</span><span class="p">(</span><span class="s1">&#39;73297adf-a0d6-4f8d-b247-0d793e577efb&#39;</span><span class="p">),</span> <span class="n">updated_at</span><span class="o">=</span><span class="n">DateTime</span><span class="p">(</span><span class="mi">2019</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">14</span><span class="p">,</span> <span class="mi">17</span><span class="p">,</span> <span class="mi">20</span><span class="p">,</span> <span class="mi">27</span><span class="p">,</span> <span class="mi">557810</span><span class="p">),</span> <span class="n">collection_count</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">parent</span><span class="o">=</span><span class="bp">None</span><span class="p">)</span>
</pre></div>


<p>You can see updated_at has been updated :) and the collection_count has increased to 2</p>
<h3 id="network-probes-example">Network Probes example<a class="headerlink" href="#network-probes-example" title="Permanent link">*</a></h3>
<p>This is a simple example running a Ping against an specific IP address and applying a custom analysis to the result.</p>
<p>First initiate the device object and specify a target</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netapi.connector.linux.subprocesser</span> <span class="kn">import</span> <span class="n">Device</span>
<span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netapi.probe.linux.subprocesser</span> <span class="kn">import</span> <span class="n">Ping</span>

<span class="o">&gt;&gt;&gt;</span> <span class="n">host</span> <span class="o">=</span> <span class="n">Device</span><span class="p">()</span>
<span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span> <span class="o">=</span> <span class="n">Ping</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="s2">&quot;1.1.1.1&quot;</span><span class="p">,</span> <span class="n">connector</span><span class="o">=</span><span class="n">host</span><span class="p">)</span>
</pre></div>


<p>You can see the <code>Ping</code> object with the following attributes:</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">ping</span><span class="p">)</span>

<span class="n">Ping</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="s1">&#39;1.1.1.1&#39;</span><span class="p">,</span><span class="n">target_ip</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">target_name</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">resolve_target</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">source</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">source_ip</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">instance</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">count</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">timeout</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">692</span><span class="p">,</span> <span class="n">df_bit</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">interval</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">ttl</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">result</span><span class="o">=</span><span class="bp">None</span><span class="p">)</span>
</pre></div>


<p>You can see that <code>result</code> attribute is empty, we need to tell to execute the <code>Ping</code> and we can apply our own logic to it.</p>
<p>The ping object is to be executed on my machine, you can see the command used on <code>ping_cmd</code>:</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span><span class="o">.</span><span class="n">generate_ping_cmd</span><span class="p">()</span>
<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">ping</span><span class="o">.</span><span class="n">ping_cmd</span><span class="p">)</span>

<span class="s1">&#39;ping 1.1.1.1 -s 692 -c 5 -W 2 -i 1.0&#39;</span>
</pre></div>


<p>If we execute it as es we can get a result like</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span><span class="o">.</span><span class="n">execute</span><span class="p">()</span>
<span class="bp">True</span>

<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span><span class="p">(</span><span class="n">ping</span><span class="p">)</span>
<span class="n">Ping</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="s1">&#39;1.1.1.1&#39;</span><span class="p">,</span>
     <span class="n">target_ip</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">target_name</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">resolve_target</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span>
     <span class="n">source</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">source_ip</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">instance</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">count</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
     <span class="n">timeout</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span>
     <span class="n">size</span><span class="o">=</span><span class="mi">692</span><span class="p">,</span>
     <span class="n">df_bit</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span>
     <span class="n">interval</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span>
     <span class="n">ttl</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
     <span class="n">result</span><span class="o">=</span><span class="n">PingResult</span><span class="p">(</span>
         <span class="n">probes_sent</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
         <span class="n">probes_received</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
         <span class="n">packet_loss</span><span class="o">=</span><span class="mf">0.0</span><span class="p">,</span>
         <span class="n">rtt_min</span><span class="o">=</span><span class="mf">25.303</span><span class="p">,</span>
         <span class="n">rtt_avg</span><span class="o">=</span><span class="mf">30.289</span><span class="p">,</span>
         <span class="n">rtt_max</span><span class="o">=</span><span class="mf">43.923</span><span class="p">,</span>
         <span class="n">warning_thld</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
         <span class="n">critical_thld</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
         <span class="n">status</span><span class="o">=</span><span class="s1">&#39;ok&#39;</span><span class="p">,</span>
         <span class="n">status_up</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span>
         <span class="n">status_code</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
         <span class="n">apply_analysis</span><span class="o">=</span><span class="bp">True</span>
    <span class="p">)</span>
<span class="p">)</span>
</pre></div>


<p>We can use our own threshold in execution to manipulate the <code>flag</code> and <code>status_up</code> parameters.</p>
<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">critical_thld</span><span class="o">=-</span><span class="mi">1</span><span class="p">)</span>
<span class="bp">True</span>

<span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span><span class="o">.</span><span class="n">result</span>

<span class="n">PingResult</span><span class="p">(</span><span class="n">probes_sent</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
           <span class="n">probes_received</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
           <span class="n">packet_loss</span><span class="o">=</span><span class="mf">0.0</span><span class="p">,</span>
           <span class="n">rtt_min</span><span class="o">=</span><span class="mf">19.241</span><span class="p">,</span>
           <span class="n">rtt_avg</span><span class="o">=</span><span class="mf">23.471</span><span class="p">,</span>
           <span class="n">rtt_max</span><span class="o">=</span><span class="mf">26.184</span><span class="p">,</span>
           <span class="n">warning_thld</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span>
           <span class="n">critical_thld</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
           <span class="n">status</span><span class="o">=</span><span class="s1">&#39;critical&#39;</span><span class="p">,</span>
           <span class="n">status_up</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span>
           <span class="n">status_code</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span>
           <span class="n">apply_analysis</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>

<span class="c1"># If you want to have a dict</span>
<span class="o">&gt;&gt;&gt;</span> <span class="n">ping</span><span class="o">.</span><span class="n">to_dict</span><span class="p">()</span>

<span class="p">{</span><span class="s1">&#39;count&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
 <span class="s1">&#39;df_bit&#39;</span><span class="p">:</span> <span class="bp">False</span><span class="p">,</span>
 <span class="s1">&#39;instance&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
 <span class="s1">&#39;interval&#39;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">,</span>
 <span class="s1">&#39;metadata&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;collection_count&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span>
              <span class="s1">&#39;created_at&#39;</span><span class="p">:</span> <span class="s1">&#39;2019-07-05T18:19:30.075757+01:00&#39;</span><span class="p">,</span>
              <span class="s1">&#39;id&#39;</span><span class="p">:</span> <span class="s1">&#39;03d55fdf-2e0d-4a66-9f18-ef33a811bc2e&#39;</span><span class="p">,</span>
              <span class="s1">&#39;implementation&#39;</span><span class="p">:</span> <span class="s1">&#39;LINUX-SUBPROCESS&#39;</span><span class="p">,</span>
              <span class="s1">&#39;name&#39;</span><span class="p">:</span> <span class="s1">&#39;ping&#39;</span><span class="p">,</span>
              <span class="s1">&#39;parent&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
              <span class="s1">&#39;type&#39;</span><span class="p">:</span> <span class="s1">&#39;entity&#39;</span><span class="p">,</span>
              <span class="s1">&#39;updated_at&#39;</span><span class="p">:</span> <span class="s1">&#39;2019-07-05T18:32:32.840095+01:00&#39;</span><span class="p">},</span>
 <span class="s1">&#39;resolve_target&#39;</span><span class="p">:</span> <span class="bp">False</span><span class="p">,</span>
 <span class="s1">&#39;result&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;apply_analysis&#39;</span><span class="p">:</span> <span class="bp">True</span><span class="p">,</span>
            <span class="s1">&#39;critical_thld&#39;</span><span class="p">:</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span>
            <span class="s1">&#39;packet_loss&#39;</span><span class="p">:</span> <span class="mf">0.0</span><span class="p">,</span>
            <span class="s1">&#39;probes_received&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
            <span class="s1">&#39;probes_sent&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
            <span class="s1">&#39;rtt_avg&#39;</span><span class="p">:</span> <span class="mf">23.732</span><span class="p">,</span>
            <span class="s1">&#39;rtt_max&#39;</span><span class="p">:</span> <span class="mf">27.673</span><span class="p">,</span>
            <span class="s1">&#39;rtt_min&#39;</span><span class="p">:</span> <span class="mf">19.733</span><span class="p">,</span>
            <span class="s1">&#39;status&#39;</span><span class="p">:</span> <span class="s1">&#39;critical&#39;</span><span class="p">,</span>
            <span class="s1">&#39;status_code&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span>
            <span class="s1">&#39;status_up&#39;</span><span class="p">:</span> <span class="bp">False</span><span class="p">,</span>
            <span class="s1">&#39;warning_thld&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">},</span>
 <span class="s1">&#39;size&#39;</span><span class="p">:</span> <span class="mi">692</span><span class="p">,</span>
 <span class="s1">&#39;source&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
 <span class="s1">&#39;source_ip&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
 <span class="s1">&#39;target&#39;</span><span class="p">:</span> <span class="s1">&#39;1.1.1.1&#39;</span><span class="p">,</span>
 <span class="s1">&#39;target_ip&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
 <span class="s1">&#39;target_name&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">,</span>
 <span class="s1">&#39;timeout&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span>
 <span class="s1">&#39;ttl&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">}</span>
</pre></div>


<p>You can see that is <code>status_up = False</code> even though all the probes were received successfully. Usefull for custom testing.</p>
<h2 id="supported-implementations">Supported Implementations<a class="headerlink" href="#supported-implementations" title="Permanent link">*</a></h2>
<p>The following reflects the supported network operating systems with their respective libraries/method of connecting, collecting and parsing data out of the device.</p>
<h3 id="connectors">Connectors<a class="headerlink" href="#connectors" title="Permanent link">*</a></h3>
<table>
<thead>
<tr>
<th>Connector Type</th>
<th>EOS</th>
<th>IOS</th>
<th>IOS-XE</th>
<th>IOS-XR</th>
<th>NXOS</th>
<th>JUNOS</th>
<th>LINUX</th>
</tr>
</thead>
<tbody>
<tr>
<td>Device</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td><code>subprocess</code>, <code>paramiko</code></td>
</tr>
</tbody>
</table>
<h3 id="network-entities">Network Entities<a class="headerlink" href="#network-entities" title="Permanent link">*</a></h3>
<table>
<thead>
<tr>
<th>Network Entity</th>
<th>EOS</th>
<th>IOS</th>
<th>IOS-XE</th>
<th>IOS-XR</th>
<th>NXOS</th>
<th>JUNOS</th>
</tr>
</thead>
<tbody>
<tr>
<td>Facts</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
</tr>
<tr>
<td>Interface</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
</tr>
<tr>
<td>Vlan</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
</tr>
<tr>
<td>Route</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
</tr>
<tr>
<td>Vrrp</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
</tr>
</tbody>
</table>
<h3 id="network-probes">Network Probes<a class="headerlink" href="#network-probes" title="Permanent link">*</a></h3>
<table>
<thead>
<tr>
<th>Network Entity</th>
<th>EOS</th>
<th>IOS</th>
<th>IOS-XE</th>
<th>IOS-XR</th>
<th>NXOS</th>
<th>JUNOS</th>
<th>LINUX</th>
</tr>
</thead>
<tbody>
<tr>
<td>Ping</td>
<td><code>pyeapi</code></td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td>❌</td>
<td><code>subprocess</code>, <code>paramiko</code></td>
</tr>
</tbody>
</table>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
        
          <a href="api/api_net_reference/" title="Builders and Net Objects" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Builders and Net Objects
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
  <div class="md-footer-social">
    <link rel="stylesheet" href="assets/fonts/font-awesome.css">
    
      <a href="https://github.com/davidban77" class="md-footer-social__link fa fa-github"></a>
    
      <a href="https://twitter.com/davidban77" class="md-footer-social__link fa fa-twitter"></a>
    
  </div>

    </div>
  </div>
</footer>
      
    </div>
    
      <script src="assets/javascripts/application.ac79c3b0.js"></script>
      
      <script>app.initialize({version:"1.0.4",url:{base:"."}})</script>
      
    
  </body>
</html>